#include <kdialog.h>
#include <klocale.h>
/****************************************************************************
** Form implementation generated from reading ui file './pluginmanager.ui'
**
** Created by User Interface Compiler
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "pluginmanager.h"

#include <qvariant.h>
#include <kstandarddirs.h>
#include <kmessagebox.h>
#include <kfiledialog.h>
#include <kdeversion.h>
#include <kio/netaccess.h>
#include <qregexp.h>
#include <qheader.h>
#include <qlistview.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include "plugincollection.h"
#include "pluginxmlparser.h"
#include "./pluginmanager.ui.h"

/*
 *  Constructs a PluginManager as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
PluginManager::PluginManager( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "PluginManager" );
    PluginManagerLayout = new QGridLayout( this, 1, 1, 11, 6, "PluginManagerLayout"); 

    _pluginList = new QListView( this, "_pluginList" );
    _pluginList->addColumn( tr2i18n( "Name" ) );
    _pluginList->addColumn( tr2i18n( "Loaded" ) );
    _pluginList->addColumn( tr2i18n( "Description" ) );
    _pluginList->addColumn( tr2i18n( "Version" ) );
    _pluginList->addColumn( tr2i18n( "Author" ) );
    _pluginList->addColumn( tr2i18n( "Function" ) );
    _pluginList->addColumn( tr2i18n( "Location" ) );

    PluginManagerLayout->addMultiCellWidget( _pluginList, 1, 5, 0, 0 );

    _install = new QPushButton( this, "_install" );

    PluginManagerLayout->addWidget( _install, 1, 1 );

    _remove = new QPushButton( this, "_remove" );
    _remove->setEnabled( FALSE );

    PluginManagerLayout->addWidget( _remove, 2, 1 );

    _close = new QPushButton( this, "_close" );

    PluginManagerLayout->addWidget( _close, 5, 1 );

    textLabel1 = new QLabel( this, "textLabel1" );

    PluginManagerLayout->addWidget( textLabel1, 0, 0 );
    spacer1 = new QSpacerItem( 51, 290, QSizePolicy::Minimum, QSizePolicy::Expanding );
    PluginManagerLayout->addItem( spacer1, 4, 1 );

    pushButton4 = new QPushButton( this, "pushButton4" );

    PluginManagerLayout->addWidget( pushButton4, 3, 1 );
    languageChange();
    resize( QSize(600, 480).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( _close, SIGNAL( clicked() ), this, SLOT( close() ) );
    connect( _pluginList, SIGNAL( selectionChanged(QListViewItem*) ), this, SLOT( selectionChanged(QListViewItem*) ) );
    connect( _install, SIGNAL( clicked() ), this, SLOT( install() ) );
    connect( _remove, SIGNAL( clicked() ), this, SLOT( remove() ) );
    connect( pushButton4, SIGNAL( clicked() ), this, SLOT( rescan() ) );

    // tab order
    setTabOrder( _pluginList, _install );
    setTabOrder( _install, _remove );
    setTabOrder( _remove, pushButton4 );
    setTabOrder( pushButton4, _close );
    init();
}

/*
 *  Destroys the object and frees any allocated resources
 */
PluginManager::~PluginManager()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void PluginManager::languageChange()
{
    setCaption( tr2i18n( "Plugin Manager" ) );
    _pluginList->header()->setLabel( 0, tr2i18n( "Name" ) );
    _pluginList->header()->setLabel( 1, tr2i18n( "Loaded" ) );
    _pluginList->header()->setLabel( 2, tr2i18n( "Description" ) );
    _pluginList->header()->setLabel( 3, tr2i18n( "Version" ) );
    _pluginList->header()->setLabel( 4, tr2i18n( "Author" ) );
    _pluginList->header()->setLabel( 5, tr2i18n( "Function" ) );
    _pluginList->header()->setLabel( 6, tr2i18n( "Location" ) );
    _install->setText( tr2i18n( "&Install..." ) );
    _remove->setText( tr2i18n( "&Remove" ) );
    _close->setText( tr2i18n( "&Close" ) );
    textLabel1->setText( tr2i18n( "Installed plugins:" ) );
    pushButton4->setText( tr2i18n( "Re&scan" ) );
}

#include "pluginmanager.moc"
